/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *
 *       PERIPHERAL TIMER
 *
 *  Module  : Library Header File
 *  File    : sg_pdtmr.h
 *  Create  : 1998-07-03
 *  Modify  : 1998-07-28
 *  Version : 1.01
 *  Note    :
 */

#ifndef _SG_PDTMR_H_
#define _SG_PDTMR_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <sg_xpt.h>

/*
 *  DEFINES / MACROS
 */

/******** G[R[h *****************************************************/
#define PDD_TMRERR_OK          0           /* G[Ȃ                   */
#define PDD_TMRERR_BUSY       (-1)         /* R}h               */
#define PDD_TMRERR_NO_TIMER   (-2)         /* ^C}ڑĂȂ     */
#define PDD_TMRERR_INVALID    (-3)         /* w肳ꂽ͖         */


/*
 *  TYPEDEFS
 */

/******** \ *******************************************************/
typedef struct {
	Uint16 year;                /* N                                      */
	Uint8 month;                /*                                       */
	Uint8 day;                  /*                                       */
	Uint8 hour;                 /*                                       */
	Uint8 minute;               /*                                       */
	Uint8 second;               /* b                                      */
	Uint8 dayofweek;            /* j( = 0, = 1, ... y = 6)         */
	                            /* ݒ莞͗LA擾͖              */
} PDS_TIME;


/******** R[obN֐ *************************************************/
typedef (*PD_TIMERCALLBACK)(Sint32 stat, Uint32 param);



/*
 *  PROTOTYPES
 */

Sint32 pdTmrIsReady(Uint32 port);
Sint32 pdTmrSetTime(Uint32 port, const PDS_TIME* time,
							PD_TIMERCALLBACK func, Uint32 param);
Sint32 pdTmrGetTime(Uint32 port, PDS_TIME*,
							PD_TIMERCALLBACK func, Uint32 param);
Sint32 pdTmrAlarm(Uint32 port, Uint8* data);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SG_PDTMR_H_ */

