/*
	Ninja Sample

	COPYRIGHT (C) SEGA ENTERSRISES,LTD.

	Multilight Sample

	1998.9.08
*/

#include <Shinobi.h>
#include <Nindows.h>

#define	OBJECT	object_tea_Teapot1E_Teapot1E

extern Uint16 T009[];
extern NJS_CNK_OBJECT OBJECT[];
extern NJS_MATRIX	matrix[8];
extern NJS_VERTEX_BUF	vbuf[4096];

NJS_TEXNAME texname[1];
NJS_TEXLIST tlist1 = {texname,1};
NJS_TEXINFO info;

NJS_TEXMEMLIST	tex[10];
NJS_VIEW	view;
NJS_PERIPHERAL *per;

Sint32	xx,yy,zz = 0;

void njUserInit(void)
{
	/* {[_[J[ɃZbg */
	njSetBorderColor(0x00000000);
	sbInitSystem( NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
	/* 2V[eV[h */
	njInitVertexBuffer( -800000, 0, 200000, 0 ,0);
	/* fobOvg̏ */
	njInitPrint(NULL,0,0);
	njInitMatrix( matrix, 8 , 0);
	njInit3D( vbuf, 4096 );
	njInitView( &view );
	njSetView( &view );

	/*NindowsŎgpeNX`*/
	njInitTexture( tex, 10 );
    njSetTextureInfo(&info,T009,NJD_TEXFMT_RGB_565|NJD_TEXFMT_TWIDDLED,128,128);
    njSetTextureName(&texname[0],&info,0,NJD_TEXATTR_TYPE_MEMORY|NJD_TEXATTR_GLOBALINDEX);
    njLoadTexture( &tlist1 );
    njSetTexture( &tlist1 );

	nwInitSystem(10,NJD_PORT_B0);

	njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR );
	njSetConstantAttr( 0xffffffff, NJD_FLAG_USE_TEXTURE | NJD_FLAG_USE_ENV|NJD_FILTER_BILINEAR);

	njSetBackColor(0x00000000,0x00000000,0x000000FF);

	njPrintSize(16);
	
	/* `NCǧ̐ݒ              *
	 * iŌݒL[Ȃ̂    *
	 *   ƃCg̎ނ͈ȉ̂悤      *
	 *   ֘A܂B                     j   *
	 *                                         *
	 * 1:sP                            *
	 * 2:sP+_Q                   *
	 * 3:sP+_Q+_R          *
	 * 4:sP+_Q+_R+_S *
	 *                                         */
	 
	njCnkSetSimpleMultiLight(4);

	/* `NCg̕siԖڂ̌jݒ */
	njCnkSetSimpleMultiLightVector(0.f, 0.f, -1.f);

	/* `NCg̓_ʒuݒ */
	/* QԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_2, 0.f, 0.f, -12.f);
	/* RԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.f, 0.f, -12.f);
	/* SԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.f, 0.f, -12.f);

	/* `NCg̓_͈́ijݒ */
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_2, 6.f, 40.f);
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_3, 6.f, 40.f);
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_4, 6.f, 40.f);

	/* `NCg̃ArGgFݒ */
	njCnkSetSimpleMultiAmbient(0.1f, 0.1f, 0.1f);

	/* `NCǧFݒ */
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_1, 0.6f, 0.5f, 0.3f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_2, 1.f, 0.5f, 0.5f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.5f, 1.f, 0.5f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.5f, 0.5f, 1.f);
}

#define RANGE	10
#define LTNUM	10
Sint32 njUserMain(void)
{
	static int _num = 0;
	static int _stop = 1;
	static int _lt_1[LTNUM]={1,0,1,0,0,0,0,0,0,0};
	static int _lt_2[LTNUM]={1,0,0,1,0,0,1,1,0,1};
	static int _lt_3[LTNUM]={1,0,0,0,1,0,1,0,1,1};
	static int _lt_4[LTNUM]={1,0,0,0,0,1,0,1,1,1};
	static char *_name[LTNUM]=
	{
		"ALL", "OFF", "DIR", "PT1", "PT2", "PT3", "P12", "P13", "P23", "P123",
	};
	
	per = njGetPeripheral(NJD_PORT_A0);
	if( per->press & NJD_DGT_TA ) {
		_num++;
		_num %= LTNUM;

		/* `NCĝnmEneeݒ               *
		 * inmFPAneeFOj                       *
		 *  ̊֐́ANJD_CNK_SIMPLE_MULTILIGHT_ALLtO *
		 *  ݒł܂Bɂݒ肳ꂽׂĂ  *
		 *  Cg؂芷܂B                      */
		 
		if (!_num) njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_ALL, 1);
		if (_num==1) njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_ALL, 0);
		else {
			njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_1, _lt_1[_num]);
			njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_2, _lt_2[_num]);
			njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_3, _lt_3[_num]);
			njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_4, _lt_4[_num]);
		}
	}
	
	njClearMatrix();
	{
		NJS_POINT3 p1,p2,p3;
		static int a1,a2,a3;
		
		a1 += 0x100;
		a2 += 0x200;
		a3 += 0x300;
		
		p1.x = RANGE * njCos(a1);
		p1.y = RANGE * njSin(a1);
		p1.z = -12.f;
		
		p2.x = RANGE * njCos(a2);
		p2.y = 0.f;
		p2.z = -12.f + RANGE * njSin(a2);
		
		p3.x = 0.f;
		p3.y = RANGE * njSin(a3);
		p3.z = -12.f + RANGE * njCos(a3);
		
		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_2, p1.x, p1.y, p1.z);
		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_3, p2.x, p2.y, p2.z);
		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_4, p3.x, p3.y, p3.z);
		
		/* `NCg̕Eʒu̔f              *
		 * ̊֐́A{IɃr[EJ̐ݒ  *
		 * ݒ肵ĂBiFnjClearMatrix̌㓙j *
		 * Oɐݒ肳ꂽׂẴCg̈ʒuE  *
		 * 𔽉f܂B                          */
		 
		njCnkSetSimpleMultiLightMatrices();
	}

	njTranslate( NULL, 0.f, 0.f, -12.f );
	njRotateXYZ( NULL, xx,yy,zz );
	njCnkSimpleMultiDrawObject( OBJECT );
	
	if (_stop) {
		xx += 257;
		yy += 179;
		zz += 193;
	}
	
	njPrint(NJM_LOCATION(2,2), "PUSH A:CHANGE LIGHT");
	njPrint(NJM_LOCATION(2,3), "LIGHT : %s", _name[_num]);
	
	if(per->press & NJD_DGT_ST){
		_stop ^= 1;
	}

	return nwExecute();
}

void njUserExit(void)
{
	/* fobOvg̏I */
	njExitPrint();
	nwExitSystem();
	njExitTexture();
	sbExitSystem();
}

