/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Middleware Wave Player Sample
 *
 *  Module  : Sample Program
 *  File    : test.c
 *  Create  : 1998-09-16
 *  Modify  : 1998-10-27
 *  Version : 1.02
 *  Note    : gCI[v`FbN[`ǉB
 */

#include	<machine.h>
#include	<shinobi.h>
#include	<sg_mw.h>


/*	TEhCu			*/
void initSnd(void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	TEhCu				*/
	/*	̓_~[							*/
	sdLibInit(NULL, 0, 0);
	/*	ubNnh				*/
	sdMemBlkCreate(&memblk);
	/*	ubNnhݒ				*/
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	TEhhCo					*/
	sdDrvInit(memblk);
	/*	ubN						*/
	sdMemBlkDestroy(memblk);
}

/* t@C[h */
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL )
		for (;;);
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

/* TEhCuEhCõo[W擾 */
void getVer(Sint32 *drvver, Sint32 *libver)
{
	Sint32	tmp;
	SDS_VER drv_ver, lib_ver;

	sdDrvGetVer(&drv_ver);
	sdLibGetVer(&lib_ver);

	tmp = (Sint32)(drv_ver.m_MajorVer);
	*drvver = tmp << 16;
	tmp = (Sint32)drv_ver.m_MinorVer;
	*drvver |= tmp << 8;
	*drvver |= (Sint32)drv_ver.m_DebugVer;

	tmp = (Sint32)(lib_ver.m_MajorVer);
	*libver = tmp << 16;
	tmp = (Sint32)lib_ver.m_MinorVer;
	*libver |= tmp << 8;
	*libver |= (Sint32)lib_ver.m_DebugVer;
	return;
}

/*	TvvȌ\		*/
void showSmpInfo(Uint32 cnt, Sint32 drvver, Sint32 libver)
{
	njPrintC(NJM_LOCATION( 5,  2), "[Wave Decoder]");
	njPrintC(NJM_LOCATION( 5,  4), "Snd Drv   : ");
	njPrintH(NJM_LOCATION(17,  4), drvver, 6);
	njPrintC(NJM_LOCATION( 5,  5), "Snd Lib   : ");
	njPrintH(NJM_LOCATION(17,  5), libver, 6);
	njPrintC(NJM_LOCATION( 5,  6), "Prg Cnt   : ");
	njPrintD(NJM_LOCATION(17,  6), cnt, 8);
	njPrintC(NJM_LOCATION( 5,  8), "File Name : SAMPLE.WAV");
	return;
}

void sfcnt2time(long sf, long ncnt, long *hh, long *mm, long *ss, long *ff)
{
	register long nf = (long)((double)ncnt/(double)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/*	ĐԂ̕\						*/
void showStat(MWPLY ply)
{
	Sint32	stat, tscl, cnt;
	Sint32	hh, mm, ss, ff;
	Sint8	*strstat[5] = {"STOP","PREP","EXEC","END ","ERROR"};

	hh = mm = ss = ff = 0;
	stat = mwPlyGetStat(ply);
	mwPlyGetTime(ply, &cnt, &tscl);
	sfcnt2time(tscl, cnt, &hh, &mm, &ss, &ff);
	njPrintC(NJM_LOCATION( 5,  9), "Frequency :");
	njPrintD(NJM_LOCATION(17,  9), tscl, 5);
	njPrintC(NJM_LOCATION( 5, 10), "Status    :");
	njPrintC(NJM_LOCATION(17, 10), strstat[stat]);
	njPrintC(NJM_LOCATION( 5, 11), "Time      :");
	njPrintD(NJM_LOCATION(17, 11), hh, 2);
	njPrintC(NJM_LOCATION(19, 11), ":");
	njPrintD(NJM_LOCATION(20, 11), mm, 2);
	njPrintC(NJM_LOCATION(22, 11), ":");
	njPrintD(NJM_LOCATION(23, 11), ss, 2);
	njPrintC(NJM_LOCATION(25, 11), ".");
	njPrintD(NJM_LOCATION(26, 11), ff, 2);
	return;
}

/* G[ */
Sint32	errcnt;

/* G[ɋN֐ */
static void errFunc(void *obj, Sint32 ecode)
{
    /* G[R[h̃`FbN */
    if (ecode != MWD_PLY_ERR_OK) {
		errcnt++;
    }
}

/* GDt@CVXẽG[ɋN֐ */
void usrGdErrFunc(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	CuI					*/
		mwPlyFinishWav();
		/*	ECȕI				*/
		sbExitSystem();
		/*	VvvCփWv			*/
		syBtExit();
 	}
 	return;
}

/* [UVSYNC荞ݓo^֐ */
static void usrVsyncFunc(void)
{
	Sint32 dstat;

    /* TEhCũT[o */
    sdSysServer();
	/* GDhCȕԃ`FbN */
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

void	main(void)
{
	MWPLY				mwply;
	MWS_PLY_CPRM_WAV	cprm;
	void				*snddrv;
	Sint32				stat;
	Uint32				cnt;
	Sint32				drvver, libver;

	/*	ECȕ				*/
    njSetBorderColor(0x00000000) ;
	sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI,NJD_FRAMEBUFFER_MODE_RGB565,1);
	njInitVertexBuffer(10000, 0, 10000, 0, 0);
    njInitPrint(NULL, 0, 0);
	njSetBackColor(0x00000000, 0x00000000, 0x000000FF);

	/*	TEhhCo̓ǂݍ			*/
	snddrv = load_file("MANATEE.DRV", NULL);
	/*	TEhCu			*/
	initSnd(snddrv);
	getVer(&drvver, &libver);
	/*	TEh̃T[oo^			*/
	njSetVSyncFunction((void *)usrVsyncFunc);

	/* GDt@CVXeG[R[obN֐̓o^	*/
	gdFsEntryErrFuncAll((void *)usrGdErrFunc, NULL);

	/*	~hEFACu		*/
	mwPlyInitWav(MWD_PLY_MN_EXEC_VSYNC);
	/*	G[֐o^						*/
	mwPlyEntryErrFunc((void *)errFunc, NULL);
	/*	nh						*/
	cprm.size  = MWD_PLY_ALLOC_SJBUF(MWD_PLY_ALLOC_LIMIT);
	cprm.buf = syMalloc(cprm.size);
	mwply = mwPlyCreateWav(&cprm);
	if (mwply == NULL)
		for (;;) ;

	/*	ĐJn							*/
	mwPlyStartFname(mwply, "SAMPLE.WAV");
	for (cnt=0;;cnt++) {
		/*	TvvȌ\		*/
		showSmpInfo(cnt, drvver, libver);
		/*	ĐԂ̕\						*/
		showStat(mwply);
		/*	ĐԂ̊mF						*/
		stat = mwPlyGetStat(mwply);
		if ((stat == MWE_PLY_STAT_PLAYEND) || (stat == MWE_PLY_STAT_ERROR)) {
			mwPlyStartFname(mwply, "SAMPLE.WAV");
		}
		/*	~hEFÃT[o֐			*/
		mwPlyExecServer();

		njWaitVSync();
	}
	/*	Đ~							*/
	mwPlyStop(mwply);
	/*	nh						*/
	mwPlyDestroy(mwply);
	syFree(cprm.buf);
	/*	CuI					*/
	mwPlyFinishWav();
	njWaitVSync();
	njWaitVSync();
	njWaitVSync();
	/*	ECȕI				*/
	sbExitSystem();
	syBtExit();
}
