/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XN[gk
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 2000

#define TEX_NUM 100
#define SIZE_CHANGE_SPEED NJM_DEG_ANG(1.0F)/* gAk̑*/

#define SCREEN_SAVE_TIME 30

static Uint32 ScaleMap[1][1] = {
    {NJM_MAP(0, 0, 0)}
};

static NJS_TEXNAME ScaleTexName[1]={
    {"frog.pvr",NJD_TEXATTR_GLOBALINDEX, 1000},
};
static NJS_TEXLIST ScaleTexList = {ScaleTexName, 1};
static NJS_SCROLL ScaleScroll;
static NJS_TEXMEMLIST ScaleTexMemList[TEX_NUM];

static NJS_MATRIX *ScaleMatrix;
static NJS_VERTEX_BUF *ScaleVbuf;
static Sint8 TextureBuf[0x40800];

/*-----------------------------------------------
    
-----------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* 蓖 */
    ScaleMatrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    ScaleVbuf   = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);

    njInitTextureBuffer( ( Sint8 * )TextureBuf, 0x800*10 );
    /* wiF̐ݒ */
    njSetBackColor(0xFF000000, 0xFF000000, 0xFF000000);
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gbNXX^bN̏ */
    njInitMatrix(ScaleMatrix, MAX_MATRIX_DEPTH, 1); 
    /* eNX`̏ */
    njInitTexture(ScaleTexMemList, TEX_NUM);
    /* XN[̐ݒ */
    ScaleScroll.celps =  256;                  /* ZTCY               */
    ScaleScroll.mapw  =    1;                  /* }bv̉̃Ž   */
    ScaleScroll.maph  =    1;                  /* }bv̏c̃Ž   */
    ScaleScroll.sx    =    1.0F;               /* XP[               */
    ScaleScroll.sy    =    1.0F;               /* XP[ c              */
    ScaleScroll.spx   =    0.0F;               /* XP[Z^[ W  */
    ScaleScroll.spy   =    0.0F;               /* XP[Z^[ W  */
    ScaleScroll.list  = &ScaleTexList;         /* eNX`Xg         */
    ScaleScroll.map   = (Uint32*)ScaleMap;     /* }bvz               */
    ScaleScroll.mflag = OFF;                   /* }gbNXtO       */
    ScaleScroll.sflag = ON;                    /* XP[tO           */
    ScaleScroll.pr    = -1000.0F;              /* vCIeB           */
    ScaleScroll.px    =     0.0F;              /* ړ W              */
    ScaleScroll.py    =     0.0F;              /* ړ W              */
    ScaleScroll.bx    =     0.0F;              /* }bv̏n W  */
    ScaleScroll.by    =     0.0F;              /* }bv̏n W  */
    ScaleScroll.cx    =     0.0F;              /* ]S W          */
    ScaleScroll.cy    =     0.0F;              /* ]S W          */
    ScaleScroll.sclc.argb.a = 255;             /* Ŝɂ `          */
    ScaleScroll.sclc.argb.r = 255;             /* Ŝɂ q          */
    ScaleScroll.sclc.argb.g = 255;             /* Ŝɂ f          */
    ScaleScroll.sclc.argb.b = 255;             /* Ŝɂ a          */
    ScaleScroll.colmode = NJD_COLOR_MODE_PACKED_TEXTURE;   /* J[[h̐ݒ */
    njLoadTexture(&ScaleTexList);
	/* F̐ݒ */
	njPrintColor(0xFFC0C0C0);
}

Sint32 njUserMain(void)
{
    static Angle size = NJM_DEG_ANG(0.0F);/* gEk̃TCY߂ϐ */
	static PDS_PERIPHERAL *key;/* {^ */
	static Bool pause = FALSE;/* |[YĂ邩ǂ */
	static int counter = 0;
	/* |[Y̔ */
	key = pdGetPeripheral(PDD_PORT_A0);

	if (key->press & PDD_DGT_ST) {
	    if (pause == FALSE) {
		    pause = TRUE;
		} else {
		    pause = FALSE;
		}
	}

    /* fobO̕\ */
    njPrintC(NJM_LOCATION(10, 3), "Ninja Sample SCROLL ZOOM");
	if (pause == TRUE) {
	    njPrintC(NJM_LOCATION(16, 5), "PAUSE");
	}
    /* g嗦ikj̕ύX */
    ScaleScroll.sx = njSin(size) + 1.5F;
    ScaleScroll.sy = njSin(size) + 1.5F;
    /* IuWFNg̕` */
	if (pause == FALSE) {
	    njDrawScroll(&ScaleScroll);
		size += SIZE_CHANGE_SPEED;
	} else {
	    counter++;
		if (counter > SCREEN_SAVE_TIME) {
		    njDrawScroll(&ScaleScroll);
		}
		if (counter == SCREEN_SAVE_TIME * 2) {
		    counter = 0;
		}
	}
    return NJD_USER_CONTINUE;
}

void njUserExit(void)
{
    /* ̊J */
    syFree(ScaleMatrix);
    syFree(ScaleVbuf);
    /* VXȅI */
	njExitPrint();
    njExitTexture();
    sbExitSystem();
}
