/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCg𓮂
  ҏW F 98-04-24 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 1
#define MAX_VERTEXES 1000

#define CENTER_X 160.0F /* XvCgXW */
#define CENTER_Y 120.0F /* XvCgYW */
#define RADIUS 50.0F   /* XvCg̔a  */

#define SCREEN_SAVE_TIME 30

static NJS_SPRITE Sprite;
static NJS_POINT3 SpritePoint;

static NJS_TEXNAME SpriteTexName[1];
static NJS_TEXLIST SpriteTexList={SpriteTexName, 1};
static NJS_TEXMEMLIST SpriteTexMem[1];
static NJS_TEXANIM SpriteAnim[] = {{64, 64, 32, 32, 0, 0, 255, 255, 0, 0}};

static NJS_VERTEX_BUF	*g_VBuf;

/*-----------------------------------------------
    
-----------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ̊蓖 */
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* wiF̐ݒ */
    njSetBackColor(0x00000000, 0x00000000, 0x00000000);
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)g_VBuf,0x800*10);
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* eNX`̏ */
    njInitTexture(&SpriteTexMem[0], 1);
    /* eNX`̓ǂݍ */
    njSetTextureName(&SpriteTexName[0],"sprite.pvr",0,NJD_TEXATTR_TYPE_FILE|NJD_TEXATTR_GLOBALINDEX);
    njLoadTexture(&SpriteTexList);
    njSetTexture(&SpriteTexList);
    njSetTextureNum(0);
	/* F̐ݒ */
	njPrintColor(0xFFC0C0C0);
}

Sint32 njUserMain(void)
{
    static Angle counter = NJM_DEG_ANG(0.0F);/* ]p̃JE^ */
	static PDS_PERIPHERAL *key;/* {^ */
	static Bool pause = FALSE;/* |[YĂ邩ǂ */
	static int pause_counter = 0;
	/* |[Y̔ */
	key = pdGetPeripheral(PDD_PORT_A0);

	if (key->press & PDD_DGT_ST) {
	    if (pause == FALSE) {
		    pause = TRUE;
		} else {
		    pause = FALSE;
		}
	}

    /* ^Cg\ */
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample SPRITE MOVEMENT");
	if (pause == TRUE) {
	    njPrintC(NJM_LOCATION(16, 7), "PAUSE");
	}
    /* _W̐ݒ */
    SpritePoint.x = CENTER_X + njCos(counter) * RADIUS;
    SpritePoint.y = CENTER_Y + njSin(counter) * RADIUS;
    /* XvCg̐ݒ */
    Sprite.sx = 1.0F;
    Sprite.sy = 1.0F;
    Sprite.p = SpritePoint;
    Sprite.tlist = &SpriteTexList;
    Sprite.tanim = SpriteAnim;
    /* XvCg̕\ */
	if (pause == FALSE) {
	    njDrawSprite2D(&Sprite, 0, -1.0F, NJD_SPRITE_ANGLE);
		counter += NJM_DEG_ANG(1.0F);
	} else {
	    pause_counter++;
		if (pause_counter > SCREEN_SAVE_TIME) {
		    njDrawSprite2D(&Sprite, 0, -1.0F, NJD_SPRITE_ANGLE);
		}
		if (pause_counter == SCREEN_SAVE_TIME * 2) {
		    pause_counter = 0;
		}
	}
    return NJD_USER_CONTINUE;
}
/*-----------------------------------
    I
-----------------------------------*/
void njUserExit(void)
{
	njExitPrint();
	njExitTexture();
    syFree(g_VBuf);
    sbExitSystem();
}
