/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCggk
  ҏW F 98-04-24 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */

#define VERTEX_MAX  1000     /* _̍ő吔 */

/* eNX`f[^ */

#define TEXTURE_NUM  1  /* eNX`f[^̐ */

/* LbVɓǂݍ܂eNX`` */

static NJS_TEXNAME g_TexName[] = {"walmap.pvr", NJD_TEXATTR_GLOBALINDEX, 0};

static NJS_TEXLIST g_TexList = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* XvCgf[^ */

static NJS_SPRITE g_Sprite;    /* XvCgf[^ێ */

/* XvCg̃Aj[Vf[^Zbg */
static NJS_TEXANIM g_SpriteAnim[] = {                      
    {256, 256, 128, 128, 0, 0, 255, 255, 0, 0}, 
};

static NJS_VERTEX_BUF *vbuf;

/* |[YtO */
Bool g_bPause = FALSE;

/* ANeBu֐ */
void ActivePhase(void);
/* |[Y֐ */
void PausePhase(void);

/***************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

***************************************************************************/

void njUserInit (void)
{
    /* ʃ[ȟ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* _̍ő吔obt@AP[g */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    vbuf = syMalloc( sizeof( NJS_VERTEX_BUF ) * 4096 );
    njInitTextureBuffer( ( Sint8 * )vbuf, 0x800*10 ); 

    /* eNX`̐f[^̈m */
    njInitTexture(g_Texture, TEXTURE_NUM);
    /* w肵eNX`XgɂeNX`f[^ */
    /* LbVɃ[h */   
    njLoadTexture(&g_TexList);  
                                
    njSetTexture(&g_TexList);   /* Jg̃eNX`Xgݒ */
    njSetTextureNum(0);       /* OԃeNX`JgeNX`ɃZbg*/

    /* XvCgf[^̏ */
    g_Sprite.p.x = 160.0F;  /* \ʒu */
    g_Sprite.p.y = 120.0F;
    g_Sprite.sx  = 1.F;    /* gk */
    g_Sprite.sy  = 1.F;
    g_Sprite.tlist = &g_TexList; /* gpeNX`Xg */
    g_Sprite.tanim = g_SpriteAnim;  /* Aj[V` */

    /* wiݒ */
    /*  E  ̃J[w */
    njSetBackColor(0xffc00000, 0xff00c000, 0xff0000c0); 

    /* eLXg̃J[ݒ */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/***************************************************************************

    njUserMain --- NinjaVXeC֐

***************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = njGetPeripheral(NJD_PORT_A0);

    /* {^ꂽǂ`FbN */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	/* |[YԂɂď؂ւ */
	if (!g_bPause) {
		ActivePhase();
	} else {
		PausePhase();
	}

    /* fobO̕\ */
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample Sprite Zoom");
    
    return NJD_USER_CONTINUE;
}


/***************************************************************************

    ActivePhase --- ANeBu֐

***************************************************************************/

void ActivePhase(void)
{
    static Angle ang = NJM_DEG_ANG(0.0F);

    /* gkω*/
    ang += 100;
    g_Sprite.sx = njSin(ang) + 0.5F;
    g_Sprite.sy = njCos(ang) + 0.5F;

    /* XvCg̕` */
    njDrawSprite2D(&g_Sprite, 0, -150.0F, 0);

	/* fobO̕\ */    
    njPrintC(NJM_LOCATION(5, 8), "sx = ");
    njPrintF(NJM_LOCATION(10, 8), g_Sprite.sx, 1);
    njPrintC(NJM_LOCATION(5, 9), "sy = ");
    njPrintF(NJM_LOCATION(10, 9), g_Sprite.sy, 1);
}


/***************************************************************************

    PausePhase --- |[Y֐

***************************************************************************/

void PausePhase(void)
{
    NJS_POINT2COL pc;
    NJS_POINT2    p[4];
    NJS_COLOR     col[4];
    static int	  timer = 0;
        
    /* XvCg̕` */
    njDrawSprite2D(&g_Sprite, 0, -150.0F, 0);

    /* Z[o[pXvCg̐ݒ */
    pc.p   = p;
    pc.col = col;
    pc.tex = NULL;
    pc.num = 4;
    
    p[0].x = 0;
    p[0].y = 0;
    col[0].color = 0xff000000;

    p[1].x = 0;
    p[1].y = 480;
    col[1].color = 0xff000000;

    p[2].x = 640;
    p[2].y = 480;
    col[2].color = 0xff000000;

    p[3].x = 640;
    p[3].y = 0;
    col[3].color = 0xff000000;

    /* Z[o[p|S̕` */
    njDrawPolygon2D(&pc, 4, -2.0F, NJD_FILL);

	/* R}[V̕\ */
	
	timer++;
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0x00));
	if (timer > 720) {
		timer = 0;
	}
					
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));				
	/* |[Ŷm点 */
    njPrintC(NJM_LOCATION(19, 15), "PAUSE");
}


/***************************************************************************

    njUserExit --- NinjaVXeI֐

***************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(vbuf);
    /* VXȅIs܂ KŌɌĂяoĂ */
    njExitSystem(); 
}
