/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F JAOύX
  ҏW F 98-04-24 Jn
              98-06-19 SET5Ή
              98-08-21  Foge[ũZbgnjUserInit̒Ɉړ

************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */

extern NJS_CNK_OBJECT   object_cube_root[];

/* }gNX֘A */
#define MATRIX_DEPTH 10
#define VERTEX_MAX   256

static NJS_MATRIX     *g_Matrix;
static NJS_VERTEX_BUF *g_VBuf;

/*   _ */
static NJS_VIEW  g_View;
static NJS_LIGHT g_Light;

/* |[YtO */
Bool g_bPause = FALSE;

/* ֐̃vg^Cv */
void ActiveProc(void);	/* ANeBu֐ */
void DrawProc(void);	/* `揈֐ */
void PauseProc(void);	/* |[Y֐ */

static NJS_FOG_TABLE fog;

/**********************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

**********************************************************************/

void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* msrbʂ̏c␳ */
    njSetAspect(1.0F, 0.45F);
    /* ̊蓖 */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    /* _i[obt@̊m */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    /* Zp_obt@̏ */
    njInit3D(g_VBuf, VERTEX_MAX);
    /* fAIuWFNg̕`Rg[ */
    njControl3D(NJD_CONTROL_3D_CONSTANT_ATTR);
    /* ̏ */
    njCreateLight(&g_Light, NJD_SPEC_DIR);
    /* r[̏ */
    njInitView(&g_View);
    /* r[̐ݒ */
    njSetView(&g_View);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));
    /* eLXg̃J[ݒ */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));

    /* tHOe[uZbg */
	njGenerateFogTable(fog);
	njSetFogTable(fog);
}


/**********************************************************************

    njUserMain --- NinjaVXeC֐

**********************************************************************/

Sint32 njUserMain(void)
{
    PDS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = pdGetPeripheral(PDD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    if (per->press & PDD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {    
	   	/* ANeBu */
		ActiveProc();
	} else {
		/* |[Y */
		PauseProc();
	}
		
    /* fobO̕\ */
    njPrintC(NJM_LOCATION(23, 5), "Ninja Sample CAMERA ANGLE");

    return NJD_USER_CONTINUE;
}



/**********************************************************************

    DrawProc --- `揈֐

**********************************************************************/

void DrawProc(void)
{
    int i, j;

    /* S̊pɗ̂zu */
    for (j = 0; j < 2; j++) {
        for (i = 0; i < 2; i++) {
            njPushMatrix(NULL);
                njTranslate(NULL, i * 10.0f - 5.0f, 0.0f, j * 10.0f - 5.0f);
                /* IuWFNg̕` */
                njCnkDrawObject(object_cube_root);
            njPopMatrix(1);
        }
    }
}


/**********************************************************************

    ActiveProc --- ANeBu֐

**********************************************************************/

void ActiveProc(void)
{
    static Angle theta = NJM_DEG_ANG(0.0F);

    /* J] */
    theta += NJM_DEG_ANG(0.5F);
    njRotateViewYAbsolute(NULL, theta);
    njSetView(&g_View);
    
    /* `揈 */
    DrawProc();
}


/**********************************************************************

    PauseProc --- |[Y֐

**********************************************************************/

void PauseProc(void)
{

	/* tHO̐ݒ */
	njSetFogColor(0x00000000);
	njSetFogDensity(0xfff0);
	njFogEnable();

	/* `揈 */
    DrawProc();

	/* tHO𖳌ɂ */
	njFogDisable();

    /* |[YԂ̕\ */
    njPrintC(NJM_LOCATION(38, 25), "PAUSE");
}


/**********************************************************************

    njUserExit --- NinjaVXeI֐

**********************************************************************/

void njUserExit(void)
{
	njExitPrint();
    /* ̊J */
    syFree(g_Matrix);
    syFree(g_VBuf);
    /* VXȅI܂ ŌɕKĂяoĂ */
    sbExitSystem();
}
