/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F NbsÖς
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 2048

#define CUBE_NUM 3                      /* ׂ闧̂̐iĂ悱j*/
#define AREA_CHANGE_CYCLE 1440          /* NbsOGA\ */
#define ROTATE_ANGLE NJM_DEG_ANG(45.0F) /* ̂\px */ 
#define AREA_CHANGE_ANGLE NJM_DEG_ANG(0.5F) /* NbsOGAύX鑬x */

extern NJS_OBJECT object_cube_root[];

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VertexBuffer;

static NJS_VIEW View;
static NJS_LIGHT DirLight;

/*----------------------------------------------------------------------
           
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* msrbʂ̏c␳ */
    njSetAspect(1.0F, 0.45F);
    /* ̊蓖 */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VertexBuffer = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0));
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(VertexBuffer, MAX_VERTEXES);
    /* ̏ */
    njCreateLight(&DirLight, NJD_DIR_LIGHT);
	njSetLightColor(&DirLight, 0.7F, 0.7F, 0.7F);
    /* r[̏ */
    njInitView(&View);
    /* r[̐ݒ */
    njSetView(&View);
	/* F̐ݒ */
	njPrintColor(0xFFC0C0C0);
}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    /* ϐ̐ݒ */

    int xPos;/* ׂ̂邽߂̃[vpJE^(c) */
    int zPos;/* ׂ̂邽߂̃[vp̃JE^ij*/
    static int counter = 0;/* NbsOGA\ԒpJE^ */
    static Angle areaAng = NJM_DEG_ANG(0.0F);/* ]pxpϐ */

	static PDS_PERIPHERAL *key;/* {^ */
	static Bool pause = FALSE;/* |[YĂ邩ǂ */

	/* |[Y̔ */
	key = pdGetPeripheral(PDD_PORT_A0);

	if (key->press & PDD_DGT_ST) {
	    if (pause == FALSE) {
		    pause = TRUE;
		} else {
		    pause = FALSE;
		}
	}

    /* NbsOGA̕ύX */
	if (pause == FALSE) {
	    counter++;
	}
    if (counter == AREA_CHANGE_CYCLE) {
        counter = 0;/* JE^[̃Zbg */
    }
    if (counter < AREA_CHANGE_CYCLE / 2) { /* O𓮂 */
        njClipZ(-10.0F - (njCos(areaAng) + 1) * 15.0F, -40.0F);
    } else {  /* 𓮂 */
        njClipZ(-10.0F , -40.0F + (njCos(areaAng) + 1) * 15.0F);
    }
    njSetView(&View);
    /* Tv̕\ */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample CLIP AREA CHANGE");
	if (pause == TRUE) {
	    njPrintC(NJM_LOCATION(30, 5), "PAUSE");
	}
    /* }gNXX^bÑNA */
    njClearMatrix();
    /* sړ */
    njTranslate(NULL, 0.0F, 0.0F, -5.0F);
    /* ׂ̂ */
    for (zPos = 0; zPos < CUBE_NUM; zPos++){
        for (xPos = 0; xPos < CUBE_NUM; xPos++){
            njPushMatrix(NULL);
            njTranslate(NULL, (xPos - 1) * -5.0F , zPos * 3.0F - 4.0F, 
                        zPos * -10.0F - 10.0F);
            /* X,Y,Z ̏Ԃɉ] */
            njRotateXYZ(NULL, ROTATE_ANGLE, ROTATE_ANGLE, ROTATE_ANGLE);
            /* IuWFNg̕` */
            njDrawObject(object_cube_root);
            njPopMatrix(1);
        };
    };
	if (pause == FALSE) {
	    areaAng += AREA_CHANGE_ANGLE;
	}
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
	njExitPrint();
    /* ̊J */
    syFree(Matrix);
    syFree(VertexBuffer);
    /* VXȅI */
    sbExitSystem();
}
