/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F }bsO{
  ҏW F 98-05-01 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>
void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[of[^ZNV */
#define MATRIX_DEPTH    12
#define VERTEX_MAX      4096

/* O`f */
extern NJS_OBJECT object_sphere[];

/* 3D֘Af[^ */
static NJS_MATRIX     *g_Matrix;   /* }gNXX^bN */
static NJS_VERTEX_BUF *g_VBuf;     /* _obt@ */

static NJS_VIEW    g_View;  /* _ */
static NJS_LIGHT   g_Light; /*  */

/* eNX`f[^ */
#define TEXTURE_NUM  1  /* eNX`f[^̐ */

/* LbVɓǂݍ܂eNX`` */
static NJS_TEXNAME g_TexName[] = {"reflect.pvr", NJD_TEXATTR_GLOBALINDEX, 0};
static NJS_TEXLIST g_TexList   = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* |[YtO */
Bool g_bPause = FALSE;

/* |[Y֐ */
void PausePhase(void);
/* ANeBu֐ */
void ActivePhase(void);


/**************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

**************************************************************************/

void njUserInit(void)
{
    /* ʃ[hݒ */
    sbInitSystem( NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);	/* o[W̃Rg[{bNXւ̑Ή */
	/* msrbʂ̏c␳ */
    njSetAspect(1.0F, 0.45F);
    /* ̊蓖 */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)g_VBuf,0x800*10);
    /* _obt@̊m */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0); 
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    /* Zp_obt@̊m */
    njInit3D(g_VBuf, VERTEX_MAX);

    /* r[̏ */
    njInitView(&g_View);
    njSetView(&g_View);

    /* Cg̏ */
    njCreateLight(&g_Light, NJD_SPEC_DIR);
    njSetLightIntensity(&g_Light, 0.2F, 1.0F, 0.4F);

    /* obNOEh̃J[ݒ */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));

    /* eNX`̃[hƃZbgAbv */
    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`f[^̈m */
    njLoadTexture(&g_TexList);  /* eNX`XgɂeNX`f[^*/
                                /* LbVɃ[h */
    njSetTexture(&g_TexList);   /* JgeNX`Xgݒ */

    /* f̃Agr[g}bv悤ɕύX */
    njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR );
    njSetConstantAttr( 0xffffffff, NJD_FLAG_USE_TEXTURE | NJD_FLAG_USE_ENV 
                                | NJD_FILTER_BILINEAR | NJD_FLAG_USE_FLAT);

	/* eLXg̃J[ݒ */
	njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**************************************************************************

    njUserMain --- NinjaVXeC֐

**************************************************************************/

Sint32 njUserMain(void)
{
    PDS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = njGetPeripheral(PDD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    if (per->press & PDD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	/* |[YԂɂď؂ւ */
	if (!g_bPause) {
		ActivePhase();
	} else {
		PausePhase();
	}

    /* fobO\ */
    njPrintC(NJM_LOCATION(23, 5), "Ninja Sample ENVIRONMENT MAPPING");

    return NJD_USER_CONTINUE;
}


/**************************************************************************

    ActivePhase --- ANeBu֐

**************************************************************************/

void ActivePhase(void)
{
    static Angle ang = NJM_DEG_ANG(0.0F);

    /* }gNX̃NA */
    njClearMatrix();

    /* ړ */
    njTranslate(NULL, 0.0F, 0.0F, -5.0F); 
    /* ] */
    ang += NJM_DEG_ANG(1.0F);
    njRotateXYZ(NULL, ang, ang, ang);

    /* ` */
    njDrawObject(object_sphere);
}


/**************************************************************************

    PausePhase --- |[Y֐

**************************************************************************/

void PausePhase(void)
{
    NJS_POINT2COL pc;
    NJS_POINT2    p[4];
    NJS_COLOR     col[4];
        
    /* pXvCg̐ݒ */
    pc.p   = p;
    pc.col = col;
    pc.tex = NULL;
    pc.num = 4;
    
    p[0].x = 0;
    p[0].y = 0;
    col[0].color = 0xff000000;

    p[1].x = 0;
    p[1].y = 480;
    col[1].color = 0xff000000;

    p[2].x = 640;
    p[2].y = 480;
    col[2].color = 0xff000000;

    p[3].x = 640;
    p[3].y = 0;
    col[3].color = 0xff000000;

    /* |S̕` */
    njDrawPolygon2D(&pc, 4, -2.0F, NJD_FILL);

    njPrintC(NJM_LOCATION(38, 30), "PAUSE");
}


/**************************************************************************

    njUserExit --- NinjaVXeI֐

**************************************************************************/

void njUserExit(void)
{
    /* ̊J */
    syFree(g_Matrix);
    syFree(g_VBuf);
    /* eNX`I */
	njExitPrint();
    njExitTexture();
    /*  VXȅIs܂ */
    sbExitSystem();
}
