
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F tHO̐ݒiԂj
  ҏW F 98-05-11 쐬Jn
              98-06-19 SET5Ή
              98-07-07 C0ĂtɑΉi|[Yǉj
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 20000
#define MAX_TEXTURE_NUM 20

extern NJS_TEXLIST texlist_air00_body_1;
extern NJS_CNK_OBJECT object_air00_body_1_body_1[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_0[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_1[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_5[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_6[];

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VBuf;
static NJS_VIEW View;
static NJS_LIGHT Light;
static NJS_TEXMEMLIST Tex[MAX_TEXTURE_NUM];
static NJS_FOG_TABLE Fog;

static PDS_PERIPHERAL *Per;

void PauseMode(void);

/************************************************************
  ֐
************************************************************/
void njUserInit(void)
{
    /* VXe */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI,NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* msrbʂ̏c␳ */
    njSetAspect(1.0F, 0.45F);
    /* obt@pAP[g */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VBuf = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* obNOEhJ[ݒ */
    njSetBackColor(ARGB(0, 150, 150, 150),ARGB(0, 150, 150, 150), ARGB(0, 150, 150, 150));
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)VBuf,0x800*10);
    /* _f[^o^pobt@AP[giP̒_US^SoCgj */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bNiPCgZp̃}gNXgpj */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* RcVXȅif`̂߂̃[Nobt@j */
    njInit3D(VBuf, MAX_VERTEXES);
    /* ̎ނ߃CgVɐݒuiso^j
      iʒu0,0,0ji0,0,-1j */
    njCreateLight(&Light, NJD_SPEC_DIR);
    /* r[̏iʒu0,0,0ji0,0,-1jiXOxj */
    njInitView(&View);
    /* [U̗pӂr[Jgr[Ɏw */
    njSetView(&View);

    /* eNX`̃[h */
    njInitTexture(Tex, MAX_TEXTURE_NUM);
    njLoadTexture(&texlist_air00_body_1);
    njSetTexture(&texlist_air00_body_1);

    /* tHOe[u̍쐬ƃfVeB̐ݒ */
    njGenerateFogTable3(Fog, -300.0F, -700.0F);
    /* gptHOe[uZbg */
    njSetFogTable(Fog);
    /* tHO̐Fw */
    njSetFogColor(ARGB(0, 150, 150, 150));
    /* tHOʂIɂ */
    njFogEnable();
    /* fobO̐F */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
************************************************************/
Sint32 njUserMain(void)
{
    static Angle angPro = NJM_DEG_ANG(0.0F);  /* vỷ]p */
    static Angle angBody = NJM_DEG_ANG(0.0F); /* s@̉]p */

    static Bool pauseMode = FALSE;

    /* Tv̕\ */
    njPrintC(NJM_LOCATION(4, 2), "Ninja Sample FOG 1");
    njPrintC(NJM_LOCATION(4, 4), "Press Start Button To Pause");

    /* ytF`FbN */
    Per = pdGetPeripheral(PDD_PORT_A0);
    if (Per->press & PDD_DGT_ST) { /* X^[g{^ꂽ */
        pauseMode = !pauseMode;
    }
    /* |[Yʂ */
    if (pauseMode == TRUE) {
        static NJS_POINT2 pnt[4] = { 0, 0, 640, 0, 640, 480, 0, 480 };
        static NJS_COLOR col[4] = {
            ARGB(150, 0, 0, 0), ARGB(150, 0, 0, 0),
            ARGB(150, 0, 0, 0), ARGB(150, 0, 0, 0),
        };
        static NJS_POINT2COL p2c = { pnt, col, NULL, 4 };

        njColorBlendingMode(0, NJD_COLOR_BLENDING_BOTHSRCALPHA);
        njDrawPolygon2D(&p2c, 4, -1.0F, NJD_FILL | NJD_TRANSPARENT);

        PauseMode();
    }

    if (pauseMode == FALSE) {
        /* s@̉] */
        angBody -= NJM_DEG_ANG(1.0F);

        /* vỷ] */
        angPro += NJM_DEG_ANG(10.0F);
        object_air00_body_1_proR_0->ang[2] = angPro;
        object_air00_body_1_proR_1->ang[2] = angPro;
        object_air00_body_1_proR_5->ang[2] = angPro;
        object_air00_body_1_proR_6->ang[2] = angPro;
    }

    /* Ԃ̃}gNXZ */
    njPushMatrix(NULL);
    njTranslate(NULL, 0.0F, 0.0F, -500.0F);
    njRotateX(NULL, angBody);
    njTranslate(NULL, 0.0F, 0.0F, -200.0F);
    njRotateX(NULL, NJM_DEG_ANG(90.0F));
    njRotateY(NULL, NJM_DEG_ANG(180.0F));
    njCnkDrawObject(object_air00_body_1_body_1);
    njPopMatrix(1);

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
************************************************************/
void njUserExit(void)
{
    /*  */
    syFree(Matrix);
    syFree(VBuf);

    /* eNX` */
	njExitPrint();
    njExitTexture();
    /* VXȅI */
    sbExitSystem();
}

/************************************************************
  |[YɌĂяo鏈
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(32);
        njPrintC(NJM_LOCATION(7, 6),"PAUSE!");
        njPrintSize(8);
    }
}
