
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F tHO̐ݒi_j
  ҏW F 98-05-11 쐬Jn
              98-06-19 SET5Ή
              98-07-08 C0ĂtɑΉi|[Yǉj
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 20000
#define MAX_TEXTURE_NUM 20

extern NJS_TEXLIST texlist_air00_body_1;
extern NJS_CNK_OBJECT object_air00_body_1_body_1[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_0[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_1[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_5[];
extern NJS_CNK_OBJECT object_air00_body_1_proR_6[];

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VBuf;
static NJS_VIEW View;
static NJS_LIGHT Light;
static NJS_TEXMEMLIST Tex[MAX_TEXTURE_NUM];
static NJS_FOG_TABLE FogOrg;
static NJS_FOG_TABLE Fog;

PDS_PERIPHERAL* Per;

void PauseMode(void);

static Sint32 fog_set_flag = 0;


/* tHOe[uZbg֐ */
void SetFogTable(void)
{
	if (fog_set_flag != 0) {
        njSetFogTable(Fog);
		fog_set_flag = 0;
	}
}
/************************************************************
  ֐
************************************************************/
void njUserInit(void)
{
    /* VXe */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* msrbʂ̏c␳ */
    njSetAspect(1.0F, 0.45F);
    /* obt@pAP[g */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VBuf = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* obNOEhJ[ݒ */
    njSetBackColor(ARGB(0, 150, 150, 150),
        ARGB(0, 150, 150, 150), ARGB(0, 150, 150, 150));
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)VBuf,0x800*10);
    /* _f[^o^pobt@AP[giP̒_US^SoCgj */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bNiPCgZp̃}gNXgpj */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* RcVXȅif`̂߂̃[Nobt@j */
    njInit3D(VBuf, MAX_VERTEXES);
    /* ̎ނ߃CgVɐݒuiso^j
      iʒu0,0,0ji0,0,-1j */
    njCreateLight(&Light, NJD_SPEC_DIR);
    /* r[̏iʒu0,0,0ji0,0,-1jiXOxj */
    njInitView(&View);
    /* [U̗pӂr[Jgr[Ɏw */
    njSetView(&View);

    /* eNX`̃[h */
    njInitTexture(Tex, MAX_TEXTURE_NUM);
    njLoadTexture(&texlist_air00_body_1);
    njSetTexture(&texlist_air00_body_1);

	/* tHOe[uZbg֐̓o^ */
	njSetEORFunction( SetFogTable );
    /* tHOe[u̍쐬ƃfVeB̐ݒ */
    njGenerateFogTable3(FogOrg, 0.0F, -700.0F);
    /* tHO̐Fw */
    njSetFogColor(ARGB(0, 150, 150, 150));
    /* tHOʂIɂ */
    njFogEnable();
    /* fobO̐F */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
************************************************************/
Sint32 njUserMain(void)
{
    static Angle angPro = NJM_DEG_ANG(0.0F); /* vỷ]p */
    static int posFog = 0;

    static Bool pauseMode = FALSE;

    /* Tv̕\ */
    njPrintC(NJM_LOCATION(4, 2), "Ninja Sample FOG 2");
    njPrintC(NJM_LOCATION(4, 4), "Press Start Button To Pause");

    /* ytF`FbN */
    Per = pdGetPeripheral(PDD_PORT_A0);
    if (Per->press & PDD_DGT_ST) { /* X^[g{^ꂽ */
        pauseMode = !pauseMode;
    }
    /* |[Yʂ */
    if (pauseMode == TRUE) {
        NJS_ARGB argb = { -0.8F, 0.0F, 0.0F, 0.0F };
        njControl3D(NJD_CONTROL_3D_CNK_CONSTANT_ATTR |
                    NJD_CONTROL_3D_OFFSET_MATERIAL);
        njSetConstantAttr(0xffffffff, NJD_FST_UA);
        njSetConstantMaterial(&argb);

        PauseMode();
    }
    else {
        njControl3D(NJD_CONTROL_3D_CNK_CONSTANT_ATTR);
        njSetConstantAttr(0xffffffff, 0);
    }

    if (pauseMode == FALSE) {
        int fog;
        for (fog = 0; fog < 128; fog++) {
            Fog[fog] = FogOrg[fog] + njSin((Angle)(NJM_DEG_ANG(1.0F) *
                360.0F * (Float)(fog + posFog) / 32.0F)) * 0.2F;
            if (Fog[fog] > 1.0F) {
                Fog[fog] = 1.0F;
            }
            if (Fog[fog] < 0.0F) {
                Fog[fog] = 0.0F;
            }
        }

        posFog++;
        if (posFog >= 128) {
            posFog = 0;
        }

        /* tHOe[ũZbgv𔭍s */
        fog_set_flag = -1;

        /* vỷ] */
        angPro += NJM_DEG_ANG(10.0F);
        object_air00_body_1_proR_0->ang[2] = angPro;
        object_air00_body_1_proR_1->ang[2] = angPro;
        object_air00_body_1_proR_5->ang[2] = angPro;
        object_air00_body_1_proR_6->ang[2] = angPro;
    }
	
    njPushMatrix(NULL);
    njTranslate(NULL, 0.0F, 0.0F, -350.0F);
    njRotateX(NULL, NJM_DEG_ANG(-10.0F));
    njRotateY(NULL, NJM_DEG_ANG(-145.0F));
    njCnkDrawObject(object_air00_body_1_body_1);
    njPopMatrix(1);

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
************************************************************/
void njUserExit(void)
{
    /*  */
    syFree(Matrix);
    syFree(VBuf);

    /* eNX` */
	njExitPrint();
    njExitTexture();
    /* VXȅI */
    sbExitSystem();
}

/************************************************************
  |[YɌĂяo鏈
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(32);
        njPrintC(NJM_LOCATION(7, 6),"PAUSE!");
        njPrintSize(8);
    }
}
