/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F _̐ݒA
              O[AtbgVF[fBO̐؂ւ
  ҏW F 98-04-30 쐬Jn
              98-06-19 SET5Ή
************************************************************/

#include <shinobi.h>
#include <njdef.h>
void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[of[^ZNV */
#define MATRIX_DEPTH    12
#define VERTEX_MAX      1024

extern NJS_CNK_OBJECT object_cube_root[];

/* 3D֘Af[^ */

static NJS_MATRIX     *g_Matrix;   /* }gNXX^bN */
static NJS_VERTEX_BUF *g_VBuf;     /* _obt@ */

static NJS_VIEW    g_View;      /* _ */
static NJS_LIGHT   g_Light; /*  */

/* |[Y֐ */
void PausePhase(void);
/* ANeBu֐ */
void ActivePhase(void);

/* |[YtO */
Bool g_bPause = FALSE;


/**************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

**************************************************************************/

void njUserInit(void)
{
    /* ʃ[hݒ */
    sbInitSystem( NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);	/* o[W̃Rg[{bNXւ̑Ή */
    /* ʂ̃AXyNgύX */
    njSetAspect(1.0F, 0.45F);
    /* ̊蓖 */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    /* _obt@̊m */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64, 0, 0); 
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* }gNXX^bN̏ */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    /* Zp_obt@̊m */
    njInit3D(g_VBuf, VERTEX_MAX);

    /* r[̏ */
    njInitView(&g_View);
    njSetView(&g_View);

    /* Cg̏ */
    njCreateLight(&g_Light, NJD_SPEC_POINT);
    njSetLightIntensity(&g_Light, 0.5F, 1.0F, 0.2F);
    njSetLightLocation(&g_Light, 0.0F, 0.0F, -7.0F);

    /* Agr[gύXł悤ɂ */
    njControl3D( NJD_CONTROL_3D_CNK_CONSTANT_ATTR );

    /* obNOEh̃J[ݒ */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                            ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));
    /* eLXg̃J[w */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**************************************************************************

    njUserMain --- NinjaVXeC֐

**************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {
	   	/* ANeBu */
		ActivePhase();
	} else {
		/* |[Y */
		PausePhase();
	}

    /* fobO\ */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample POINT LIGHT");

    return NJD_USER_CONTINUE;
}


/**************************************************************************

    ActivePhase --- ANeBu֐

**************************************************************************/

void ActivePhase(void)
{
    static Angle x_ang = NJM_DEG_ANG(0.0F);
    static Angle y_ang = NJM_DEG_ANG(0.0F);
    static Angle z_ang = NJM_DEG_ANG(0.0F);

    static int time = 0;

    /* oߎԂɂVF[fBO؂ւ */
    if (++time > 600) {
        time = 0;
    }
    if (time < 300) {
        njSetConstantAttr( 0xffffffff, NJD_FST_FL );
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Flat");
    } else {
        njSetConstantAttr( 0xffffffff, 0);
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Gouraud");
    }

    /* }gNX̃NA */
    njClearMatrix();

    /* ړ */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F); 
    /* ] */
    x_ang += NJM_DEG_ANG(1.0F);
    y_ang += NJM_DEG_ANG(1.0F);
    z_ang += NJM_DEG_ANG(1.0F);
    njRotateXYZ(NULL, x_ang, y_ang, z_ang);

    /* ` */
    njCnkDrawObject(object_cube_root);
}


/**************************************************************************

    PausePhase --- |[Y֐

**************************************************************************/

void PausePhase(void)
{
	static NJS_FOG_TABLE fog;

	/* tHO̐ݒ */
	njSetFogColor(0x00000000);
	njSetFogDensity(0xfff0);
	njGenerateFogTable(fog);
	njSetFogTable(fog);
	njFogEnable();

    /* ` */
    njCnkDrawObject(object_cube_root);

	/* tHO𖳌ɂ */
	njFogDisable();

    /* |[YԂ̕\ */
    njPrintC(NJM_LOCATION(38, 25), "PAUSE");
}


/**************************************************************************

    njUserExit --- NinjaVXeI֐

**************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    /* ̊J */
    syFree(g_Matrix);
    syFree(g_VBuf);
    /*  VXȅIs܂ */
    sbExitSystem();
}
